//
// C++ Implementation: qfsqlfield
//
// Description:
//
//
// Author: Fanda Vacek <fanda.vacek@volny.cz>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include <QVariant>
#include <QString>
#include <QTextStream>

#include <qfcoreglobal.h>

#include "qf.h"
#include "qfsql.h"
#include "qfsqlfield.h"

#include <qflogcust.h>

QFSqlField::QFSqlField(bool)
{
	d = new Data();
}

QFSqlField::QFSqlField()
{
	*this = sharedNull();
}

QFSqlField::QFSqlField( const QString & fieldName, QVariant::Type type)
	: QSqlField(fieldName, type)
{
	d = new Data;
}

QFSqlField::QFSqlField(const QFSqlField &other)
	: QSqlField(other)
{
	d = other.d;
}

QFSqlField::QFSqlField(const QSqlField &other)
	: QSqlField(other)
{
	d = new Data;
}

const QFSqlField& QFSqlField::sharedNull()
{
	static QFSqlField n(true);
	return n;
}

bool QFSqlField::isReadOnly() const
{
	return QSqlField::isReadOnly();// || !isUpdateable();
}

QString QFSqlField::toString(const QString &indent) const
{
	QString s;
	QTextStream ts(&s, QIODevice::WriteOnly);
	//ts << indent << "table: " << tableName() << QF_EOLN;
	ts << indent << "name: " << name() << QF_EOLN;
	ts << indent << "full name: " << fullName() << QF_EOLN;
	ts << indent << "type: " << QVariant::typeToName(type()) << QF_EOLN;
	ts << indent << "length: " << length() << QF_EOLN;
	ts << indent << "precision: " << precision() << QF_EOLN;
	ts << indent << "default value: " << defaultValue().toString() << QF_EOLN;
	ts << indent << "required: " << requiredStatus() << QF_EOLN;
	ts << indent << "autogenerated: " << isAutoValue() << QF_EOLN;
	ts << indent << "read only: " << isReadOnly() << QF_EOLN;
	//ts << indent << "dirty: " << isDirty() << QF_EOLN;
	ts << flush;
	return s;
}

QString QFSqlField::fieldName() const
{
	QString ret = driverReportedName();
	QFSql::parseFullName(ret, &ret);
	//qfTrash() << "name:" << ret;
	return ret;
}

QString QFSqlField::fullName() const
{
	QString s;
	if(!d->fullname.isEmpty()) s = d->fullname;
	else s = driverReportedName();
	return s;
	//return QFSql::prependDot(s);
}

QString QFSqlField::fullTableName() const
{
	QString tbl, db;
	QFSql::parseFullName(fullName(), NULL, &tbl, &db);
	return QFSql::composeFullName(tbl, db);
}

QString QFSqlField::tableName() const
{
	QString ret;
	QFSql::parseFullName(fullName(), NULL,  &ret);
	return ret;
}

QString QFSqlField::dbName() const
{
	QString ret;
	QFSql::parseFullName(fullName(), NULL, NULL, &ret);
	return ret;
}

void QFSqlField::setValue(const QVariant & value)
{
	qfLogFuncFrame() << fieldName();
	QVariant v = value;
	static const QString empty_string = QString("");
	//qfTrash() << "\tvalue before:" << v.toString();
	qfTrash().noSpace() << "\tvalue: " << v.toString() << " type: " << v.typeName() << " is valid: " << v.isValid() << " is null: " << v.isNull() << " isNullable: " << isNullable();
	if(!isNullable() && v.isNull()) {
		/// preved null na neco not null
		QVariant::Type t = type();
		switch(t) {
			case QVariant::String:
				v = empty_string;
				break;
				/// tyhle typy maji vlastni is_null flag v implementaci QVariantu
				/// bohuzel treba QDate ne KURVA!!!
			case QVariant::Date:
				v = 0;
				/// v pripade Date musim field dokonce pretypovat, jinak mi to hodi do SQL SET fieldname=NULL
				setType(QVariant::Int);
				//v = empty_string;
				break;
			case QVariant::Int:
			case QVariant::UInt:
			case QVariant::LongLong:
			case QVariant::ULongLong:
			case QVariant::Bool:
			case QVariant::Double:
				v = QVariant(t);
				v = 0;
				break;
			default: v = QVariant(t);
		}
		/*
		if(!v.isValid()) v = 0; /// tohle uz je zoufalstvi
		else if(v.type() == QVariant::String) v = QString("");
		else v = QFSql::retypeVariant(v, type()).toString();
		*/
		qfTrash().noSpace() << "\tinsert null value to not null field, converting NULL to value: " << v.toString() << " type:" << v.typeName();
	}
	else {
		if(v.isValid()) v = Qf::retypeVariant(v, type());
	}
	if(!isNullable() && v.isValid()) {
		/// QT SQL driver da NULL, jakmile je QDateTime, QDate, nebo QTime neplatne
		/// MySql, ale umi NOT NULL invalid DateTime
		QVariant::Type t = type();
		switch(t) {
			case QVariant::Date:
				if(!v.toDate().isValid()) {
					setType(QVariant::Int);
					v = 0;
				}
				break;
			case QVariant::Time:
				if(!v.toTime().isValid()) {
					setType(QVariant::Int);
					v = 0;
				}
				break;
			case QVariant::DateTime:
				if(!v.toDateTime().isValid()) {
					setType(QVariant::Int);
					v = 0;
				}
				break;
			default: break;
		}
	}
	qfTrash().noSpace() << "\tretyped value:" << v.toString() << " type: " << v.typeName() << " is valid: " << v.isValid() << " is null: " << v.isNull();
	/*
	switch(type()) {
		case QVariant::Int:
			if(v.toString().isEmpty()) v = QVariant(0);
		default:
			break;
	}
	*/
	//qfTrash() << "\tvalue after:" << v.toString();
	if(!v.isValid()) {
		qfTrash() << "\t NULL value";
		QSqlField::clear();
	}
	else QSqlField::setValue(v);
}
